# Class MeshData

java.lang.Object
org.jmol.util.MeshSurface
org.jmol.jvxl.data.MeshData

public class MeshData extends MeshSurface

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected class`
`MeshData.SortSet`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`MODE_GET_COLOR_INDEXES`
`static final int`
`MODE_GET_VERTICES`
`static final int`
`MODE_PUT_SETS`
`static final int`
`MODE_PUT_VERTICES`
`String`
`polygonColorData`
`int`
`vertexIncrement`

### Fields inherited from class MeshSurface

`altVertices, bsDisplay, bsPolygons, bsSlabDisplay, bsSlabGhost, colix, colixBack, colorsExplicit, dataOnly, haveQuads, iA, iB, iC, isColorSolid, isDrawPolygon, isMerged, mat4, mergePolygonCount0, mergeVertexCount0, meshType, normalCount, normals, normalsTemp, normixCount, nSets, oabc, offset, P_CHECK, P_CONTOUR, P_EXPLICIT_COLOR, pc, pcs, pis, polygonCount0, SEED_COUNT, slabColix, slabMeshType, slabOptions, surfaceAtoms, surfaceSet, vc, vcs, vertexCount0, vertexSets, vertexSource, vs, vvs, vwr`

## Constructor Summary

Constructors
Constructor
Description
`MeshData()`

## Method Summary

Modifier and Type
Method
Description
`int`
`addVertexCopy(T3 vertex, float value, int assocVertex, boolean asCopy)`
`static Object`
`calculateVolumeOrArea(MeshData m, BS thisSet, boolean isArea, boolean getSets)`
`static boolean`
`checkCutoff(int iA, int iB, int iC, float[] vertexValues)`
`BS[]`
`getSurfaceSet()`
`void`
`invalidateSurfaceSet(int i)`
`void`
`invalidateVertices(BS bsInvalid)`
`void`
`setVertexSets(boolean onlyIfNull)`
`void`
`updateInvalidatedVertices(BS bs)`

### Methods inherited from class MeshSurface

`addPolygon, addPolygonC, addQuad, addTriangle, addTriangleCheck, addV, addVCVal, getFaces, getMeshSlicer, getResolution, getSlabColor, getSlabType, getSphereData, getSphericalInterpolationFraction, getVertices, invalidatePolygons, newMesh, resetSlab, setABC, setBoundingBox, setBox, setColix, setColixBack, setPolygonCount, setTranslucentVertices, slabBrillouin, slabPolygonsList`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### MODE_GET_VERTICES

public static final int MODE_GET_VERTICES

See Also:
  - Constant Field Values

### MODE_GET_COLOR_INDEXES

public static final int MODE_GET_COLOR_INDEXES

See Also:
  - Constant Field Values

### MODE_PUT_SETS

public static final int MODE_PUT_SETS

See Also:
  - Constant Field Values

### MODE_PUT_VERTICES

public static final int MODE_PUT_VERTICES

See Also:
  - Constant Field Values

### vertexIncrement

public int vertexIncrement

### polygonColorData

public String polygonColorData

## Constructor Details

### MeshData

public MeshData()

## Method Details

### addVertexCopy

public int addVertexCopy(T3 vertex, float value, int assocVertex, boolean asCopy)

### getSurfaceSet

public BS[] getSurfaceSet()

### setVertexSets

public void setVertexSets(boolean onlyIfNull)

### invalidateSurfaceSet

public void invalidateSurfaceSet(int i)

### checkCutoff

public static boolean checkCutoff(int iA, int iB, int iC, float[] vertexValues)

### calculateVolumeOrArea

public static Object calculateVolumeOrArea(MeshData m, BS thisSet, boolean isArea, boolean getSets)

Parameters:
  `m` -
  `thisSet` - set to Integer.MIN_VALUE to ensure an array. If a set has been selected, we return a Float
  `isArea` -
  `getSets` -
Returns:
  Float or double[]

### updateInvalidatedVertices

public void updateInvalidatedVertices(BS bs)

### invalidateVertices

public void invalidateVertices(BS bsInvalid)